#include "common.h"
#include "bull_cow.c"

bool retrans( int sc ) {
   char data[ MAXLINE ];
   int rc = read( sc, data, MAXLINE );
   if( rc > 0 ) {
      if( debug ) printf( "[%05u] %s", getpid(), data );
      bull_cow( data );
      rc = write( sc, data, strlen( data ) + 1 );
      if ( rc < 0 ) perror( "write data failed" );
      return rc > 0;
   }
   if( rc < 0 ) 
      perror( "read data failed" );
   if( rc == 0 )  
      printf( "client close connection\n" ); 
   return false;
}

int main( int argc, char *argv[] ) {
   in_port_t port = FORK_PORT;
   int opt;
   while ( ( opt = getopt( argc, argv, "p:v") ) != -1 )
      switch( opt ) { 
         case 'p' :
            if( atoi( optarg ) > 0 ) port = atoi( optarg );
            break;
         case 'v' :
            debug = true;
            break;
         default :
            return 1;
      }
   int ls, rs;
   struct sockaddr_in addr;
   if( -1 == ( ls = socket( AF_INET, SOCK_STREAM, 0 ) ) ) { 
      printf( "create stream socket failed\n" );
      return 1;
   }
   if( setsockopt( ls, SOL_SOCKET, SO_REUSEADDR, &rs, sizeof( rs ) ) != 0 ) {
      printf( "set socket option failed\n" );
      return 1;
   }
   memset( &addr, 0, sizeof( addr ) );
   addr.sin_family = AF_INET;
   addr.sin_port = htons( port );
   addr.sin_addr.s_addr = htonl( INADDR_ANY );
   if( bind( ls, (struct sockaddr*)&addr, sizeof( struct sockaddr ) ) != 0 ) {
      printf( "bind socket address failed\n" );
      return 1;
   }
   if( listen( ls, 25 ) != 0 ) { 
      printf( "put socket in listen state failed\n" );
      return 1;
   }
   if( debug )
      printf( "[%05u] waiting on port %u\n", getpid(), port );
   while( true ) {
      if( ( rs = accept( ls, NULL, NULL ) ) < 0 ) { 
         printf( "accept error\n" );
         return 1;
      }     
      pid_t pid = fork();
      if( pid < 0 ) { 
         printf( "fork error\n" );
         return 1;         
      } 
      if( pid == 0 ) {           // дочерний серверный процесс
         close( ls );
         while( retrans( rs ) ); // обмен с клиентом
         close( rs );
         exit( EXIT_SUCCESS );
      }
      else close( rs );
   }
   exit( EXIT_SUCCESS );
}
